/*
Blink using Timer interrupts
from Linux Format 154
based on code and ideas from:
arduino playground - www.arduino.cc
Michael Smith <michael@hurts.ca>
Atmel datasheets - http://www.atmel.com/
*/

const int LedPin = 13;
boolean value=false;

void setup() {
pinMode(LedPin, OUTPUT);

TIMSK1= 0x01; // enable timer overflow interrupt
TCNT1=0x0000; // reset counter to 0 at start
TCCR1A = 0x00; // set Timer Counter Control Register A - turn off PWM and OCR;
TCCR1B = 0x04; // set Timer Counter Control Register B - prescalar to /256


// start serial access - this is to get around a bug on some
// systems which don't initialise the data segment properly
Serial.begin(9600);
};

void loop () {

digitalWrite(LedPin,value);
};

ISR(TIMER1_OVF_vect) {
//toggle the value
value=!value;
};
