/*
Blink using Timer interrupts
from Linux Format 154
based on code and ideas from:
arduino playground - www.arduino.cc
Michael Smith <michael@hurts.ca>
Atmel datasheets - http://www.atmel.com/
*/

/* LISTING 2
* In this version we use the PORTB register to access the LED pin,   
* and set it directly from our interrupt routine. this leaves the main loop of the code empty
* for your own stuff
*/



void setup() {

cli(); // stop interrupts while we meddle with the clocks
DDRB = DDRB | B00100000;
TIMSK1=0x01; // enable timer overflow interrupt
TCNT1=0x0000; // reset counter to 0 at start
TCCR1A = 0x00; // set Timer Counter Control Register A - turn off PWM and OCR;
TCCR1B = 0x04; // set Timer Counter Control Register B - prescalar to /256
sei(); //start interrupts again

// start serial access - this is to get around a bug on some
// systems which don't initialise the data segment properly
Serial.begin(9600);
};

void loop () {
delay(5000);
};

ISR(TIMER1_OVF_vect) {
//toggle the value
PORTB ^= _BV(PB5);
// this works by XORing the bit with 1, which turns 1 to 0 and 0 to 1
};

